diff -ruwN ipac-ng-1.31.orig/agents/iptables/iptables.c ipac-ng-1.31/agents/iptables/iptables.c
--- ipac-ng-1.31.orig/agents/iptables/iptables.c	2004-06-28 00:08:54.000000000 +0200
+++ ipac-ng-1.31/agents/iptables/iptables.c	2005-05-02 11:48:19.816750880 +0200
@@ -62,10 +62,6 @@
 #define FALSE 0
 #endif
 
-#ifndef IPT_LIB_DIR
-#define IPT_LIB_DIR "/lib/iptables"
-#endif
-
 #define FMT_NUMERIC	0x0001
 #define FMT_NOCOUNTS	0x0002
 #define FMT_KILOMEGAGIGA 0x0004
@@ -91,7 +87,6 @@
 static struct option *opts = original_opts;
 static unsigned int global_option_offset = 0;
 
-extern char *authhost;
 
 /* - T.Mohan 5/7/2001
  * interface structure to pass to append rule
@@ -105,6 +100,20 @@
 
 typedef struct iface_struct s_iface;
 
+struct ipt_get_revision
+{
+	char name[IPT_FUNCTION_MAXNAMELEN-1];
+
+	u_int8_t revision;
+};
+
+struct iptables_rule_match
+{
+	struct iptables_rule_match *next;
+
+	struct iptables_match *match;
+};
+
 
 /* Include file for additions: new matches and targets. */
 struct iptables_match
@@ -113,6 +122,9 @@
 
 	ipt_chainlabel name;
 
+	/* Revision of match (0 by default). */
+	u_int8_t revision;
+
 	const char *version;
 
 	/* Size of match data. */
@@ -152,7 +164,6 @@
 	unsigned int option_offset;
 	struct ipt_entry_match *m;
 	unsigned int mflags;
-	unsigned int used;
 };
 
 struct iptables_target
@@ -161,6 +172,9 @@
 
 	ipt_chainlabel name;
 
+	/* Revision of target (0 by default). */
+	u_int8_t revision;
+
 	const char *version;
 
 	/* Size of target data. */
@@ -202,6 +216,7 @@
 	unsigned int used;
 };
 
+
 enum ipt_tryload {
 	DONT_LOAD,
 	TRY_LOAD,
@@ -246,6 +261,9 @@
  * compiler warning.
  */
 
+char *lib_dir = "/lib/iptables";
+
+
 void
 exit_error(enum exittype status, char *msg, ...)
 {
@@ -367,7 +385,7 @@
  * iptables-1.2.2  file:iptables.c 
  */
 
-void
+static void
 parse_interface(const char *arg, char *vianame, unsigned char *mask)
 {
 	int vialen = strlen(arg);
@@ -382,23 +400,25 @@
 			   " (%i)", arg, IFNAMSIZ-1);
 
 	strcpy(vianame, arg);
-	if (vialen == 0)
+	if ((vialen == 0) || (vialen == 1 && vianame[0] == '+'))
 		memset(mask, 0, IFNAMSIZ);
 	else if (vianame[vialen - 1] == '+') {
 		memset(mask, 0xFF, vialen - 1);
 		memset(mask + vialen - 1, 0, IFNAMSIZ - vialen + 1);
+		/* Don't remove `+' here! -HW */
 	} else {
 		/* Include nul-terminator in match */
 		memset(mask, 0xFF, vialen + 1);
 		memset(mask + vialen + 1, 0, IFNAMSIZ - vialen - 1);
-	}
 	for (i = 0; vianame[i]; i++) {
 		if (!isalnum(vianame[i])
                     && vianame[i] != '_'
-		    && vianame[i] != '+'
                     && vianame[i] != '.') {
-			exit_error(PARAMETER_PROBLEM, "Warning: weird character in interface"
-			       " `%s' (No aliases, :, ! or *).\n", vianame);
+				printf("Warning: wierd character in interface"
+				       " `%s' (No aliases, :, ! or *).\n",
+				       vianame);
+				break;
+			}
 		}
 	}
 }
@@ -429,20 +449,27 @@
 }
 
 int
-check_inverse(const char option[], int *invert)
+check_inverse(const char option[], int *invert, int *optind, int argc)
 {
 	if (option && strcmp(option, "!") == 0) {
 		if (*invert)
 			exit_error(PARAMETER_PROBLEM,
 				   "Multiple `!' flags not allowed");
-
 		*invert = TRUE;
+		if (optind) {
+			*optind = *optind+1;
+			if (argc && *optind > argc)
+				exit_error(PARAMETER_PROBLEM,
+					   "no argument following `!'");
+		}
+
 		return TRUE;
 	}
 	return FALSE;
 }
 
 // ---------------------------------------------------------------------
+/* code copied from iptables 1.3.1                                     */
 // ---------------------------------------------------------------------
 
 static char *
@@ -509,7 +536,7 @@
 	return addr_to_dotted(addr);
 }
 
-static char *
+char *
 mask_to_dotted(const struct in_addr *mask)
 {
 	int i;
@@ -535,22 +562,19 @@
 	return buf;
 }
 
+
 static struct ipt_entry *
 generate_entry(const struct ipt_entry *fw,
-	       struct iptables_match *matches,
+	       struct iptables_rule_match *matches,
 	       struct ipt_entry_target *target)
 {
 	unsigned int size;
-	struct iptables_match *m;
+	struct iptables_rule_match *matchp;
 	struct ipt_entry *e;
 
 	size = sizeof(struct ipt_entry);
-	for (m = matches; m; m = m->next) {
-		if (!m->used)
-			continue;
-
-		size += m->m->u.match_size;
-	}
+	for (matchp = matches; matchp; matchp = matchp->next)
+		size += matchp->match->m->u.match_size;
 
 	e = xmalloc(size + target->u.target_size);
 	*e = *fw;
@@ -558,12 +582,9 @@
 	e->next_offset = size + target->u.target_size;
 
 	size = 0;
-	for (m = matches; m; m = m->next) {
-		if (!m->used)
-			continue;
-
-		memcpy(e->elems + size, m->m, m->m->u.match_size);
-		size += m->m->u.match_size;
+	for (matchp = matches; matchp; matchp = matchp->next) {
+		memcpy(e->elems + size, matchp->match->m, matchp->match->m->u.match_size);
+		size += matchp->match->m->u.match_size;
 	}
 	memcpy(e->elems + size, target, target->u.target_size);
 
@@ -575,15 +596,17 @@
 	int procfile;
 	char *ret;
 
+#define PROCFILE_BUFSIZ	1024
 	procfile = open(PROC_SYS_MODPROBE, O_RDONLY);
 	if (procfile < 0)
 		return NULL;
 
-	ret = malloc(1024);
+	ret = (char *) malloc(PROCFILE_BUFSIZ);
 	if (ret) {
-		switch (read(procfile, ret, 1024)) {
+		memset(ret, 0, PROCFILE_BUFSIZ);
+		switch (read(procfile, ret, PROCFILE_BUFSIZ)) {
 		case -1: goto fail;
-		case 1024: goto fail; /* Partial read.  Wierd */
+		case PROCFILE_BUFSIZ: goto fail; /* Partial read.  Wierd */
 		}
 		if (ret[strlen(ret)-1]=='\n') 
 			ret[strlen(ret)-1]=0;
@@ -618,22 +641,22 @@
 	}
 
 	if (!ptr && tryload != DONT_LOAD) {
-		char path[sizeof(IPT_LIB_DIR) + sizeof("/libipt_.so")
+		char path[strlen(lib_dir) + sizeof("/libipt_.so")
 			 + strlen(name)];
-		sprintf(path, IPT_LIB_DIR "/libipt_%s.so", name);
+		sprintf(path, "%s/libipt_%s.so", lib_dir, name);
 		if (dlopen(path, RTLD_NOW)) {
 			/* Found library.  If it didn't register itself,
 			   maybe they specified match as a target. */
 			ptr = find_target(name, DONT_LOAD);
 			if (!ptr) {
-				fprintf(stderr, "Couldn't load target `%s'\n",
+				exit_error(PARAMETER_PROBLEM,
+					   "Couldn't load target `%s'\n",
 					   name);
-				exit(1);
 			}
 		} else if (tryload == LOAD_MUST_SUCCEED) {
-			fprintf(stderr, "Couldn't load target `%s':%s\n",
+			exit_error(PARAMETER_PROBLEM,
+				   "Couldn't load target `%s':%s\n",
 				   name, dlerror());
-			exit(1);
 			}
 	}
 
@@ -647,8 +670,9 @@
 {
 	char *buf = NULL;
 	char *argv[3];
+	int status;
 
-//	 If they don't explicitly set it, read out of kernel 
+	/* If they don't explicitly set it, read out of kernel */
 	if (!modprobe) {
 		buf = get_modprobe();
 		if (!buf)
@@ -664,16 +688,18 @@
 		execv(argv[0], argv);
 
 //		 not usually reached 
-		exit(0);
+		exit(1);
 	case -1:
 		return -1;
 
 	default: // parent 
-		wait(NULL);
+		wait(&status);
 	}
 
 	free(buf);
+	if (WIFEXITED(status) && WEXITSTATUS(status) == 0)
 	return 0;
+	return -1;
 }
 
 void
@@ -687,7 +713,7 @@
 
 	if (me->size != IPT_ALIGN(me->size)) {
 		fprintf(stderr, "%s: target `%s' has invalid size %u.\n",
-			"fddfgdsse", me->name, me->size);
+			"fddfgdsse", me->name, (unsigned int)me->size);
 		exit(1);
 	}
 
@@ -698,20 +724,17 @@
 	me->tflags = 0;
 }
 
-unsigned char * make_delete_mask(struct ipt_entry *fw)
+static unsigned char *
+make_delete_mask(struct ipt_entry *fw, struct iptables_rule_match *matches)
 {
 	/* Establish mask for comparison */
 	unsigned int size;
-	struct iptables_match *m;
+	struct iptables_rule_match *matchp;
 	unsigned char *mask, *mptr;
 
 	size = sizeof(struct ipt_entry);
-	for (m = iptables_matches; m; m = m->next) {
-		if (!m->used)
-			continue;
-
-		size += IPT_ALIGN(sizeof(struct ipt_entry_match)) + m->size;
-	}
+	for (matchp = matches; matchp; matchp = matchp->next)
+		size += IPT_ALIGN(sizeof(struct ipt_entry_match)) + matchp->match->size;
 
 	mask = xcalloc(1, size
 			 + IPT_ALIGN(sizeof(struct ipt_entry_target))
@@ -720,14 +743,11 @@
 	memset(mask, 0xFF, sizeof(struct ipt_entry));
 	mptr = mask + sizeof(struct ipt_entry);
 
-	for (m = iptables_matches; m; m = m->next) {
-		if (!m->used)
-			continue;
-
+	for (matchp = matches; matchp; matchp = matchp->next) {
 		memset(mptr, 0xFF,
 		       IPT_ALIGN(sizeof(struct ipt_entry_match))
-		       + m->userspacesize);
-		mptr += IPT_ALIGN(sizeof(struct ipt_entry_match)) + m->size;
+		       + matchp->match->userspacesize);
+		mptr += IPT_ALIGN(sizeof(struct ipt_entry_match)) + matchp->match->size;
 	}
 
 	memset(mptr, 0xFF,
@@ -738,7 +758,7 @@
 }
 
 struct iptables_match *
-find_match(const char *name, enum ipt_tryload tryload)
+find_match(const char *name, enum ipt_tryload tryload, struct iptables_rule_match **matches)
 {
 	struct iptables_match *ptr;
     
@@ -748,28 +768,37 @@
 	}
 
 	if (!ptr && tryload != DONT_LOAD) {
-		char path[sizeof(IPT_LIB_DIR) + sizeof("/libipt_.so")
+		char path[strlen(lib_dir) + sizeof("/libipt_.so")
 			 + strlen(name)];
-		sprintf(path, IPT_LIB_DIR "/libipt_%s.so", name);
+		sprintf(path, "%s/libipt_%s.so", lib_dir, name);
 		if (dlopen(path, RTLD_NOW)) {
 			/* Found library.  If it didn't register itself,
 			   maybe they specified target as match. */
-			ptr = find_match(name, DONT_LOAD);
+			ptr = find_match(name, DONT_LOAD, NULL);
 
 			if (!ptr) {
-				fprintf(stderr, "Couldn't load match `%s'\n",
+				exit_error(PARAMETER_PROBLEM,
+					   "Couldn't load match `%s'\n",
 					   name);
-				exit(1);
 			}
 		} else if (tryload == LOAD_MUST_SUCCEED) {
-			fprintf(stderr, "Couldn't load match `%s':%s\n",
+			exit_error(PARAMETER_PROBLEM,
+				   "Couldn't load match `%s':%s\n",
 				   name, dlerror());
-			exit(1);
 		}
 	}
 
-	if (ptr)
-		ptr->used = 1;
+	if (ptr && matches) {
+		struct iptables_rule_match **i;
+		struct iptables_rule_match *newentry;
+
+		newentry = xmalloc(sizeof(struct iptables_rule_match));
+
+		for (i = matches; *i; i = &(*i)->next);
+		newentry->match = ptr;
+		newentry->next = NULL;
+		*i = newentry;
+	}
 
 	return ptr;
 }
@@ -779,7 +808,7 @@
 {
 	struct iptables_match **i;
 
-	if (find_match(me->name, DONT_LOAD)) {
+	if (find_match(me->name, DONT_LOAD, NULL)) {
 		fprintf(stderr, "%s: match `%s' already registered.\n",
 			"fetchipac??", me->name);
 		exit(1);
@@ -787,7 +816,7 @@
 
 	if (me->size != IPT_ALIGN(me->size)) {
 		fprintf(stderr, "%s: match `%s' has invalid size %u.\n",
-			"fetchipac??", me->name, me->size);
+			"fetchipac??", me->name, (unsigned int)me->size);
 		exit(1);
 	}
 
@@ -801,16 +830,21 @@
 }
 
 
+/* Christophe Burki wants `-p 6' to imply `-m tcp'.  */
 static struct iptables_match *
-find_proto(const char *pname, enum ipt_tryload tryload, int nolookup)
+find_proto(const char *pname, enum ipt_tryload tryload, int nolookup, struct iptables_rule_match **matches)
 {
-	int proto;
+	unsigned int proto;
+
+	if ((proto = string_to_number(pname, 0, 255)) != -1) {
+		char *protoname = proto_to_name(proto, nolookup);
 
-	proto = string_to_number(pname, 0, 255);
-	if (proto != -1)
-		return find_match(proto_to_name(proto, nolookup), tryload);
+		if (protoname)
+			return find_match(protoname, tryload, matches);
+	} else
+		return find_match(pname, tryload, matches);
 
-	return find_match(pname, tryload);
+	return NULL;
 }
 
 static void
@@ -823,15 +857,19 @@
 				number = (number + 500) / 1000;
 				if (number > 9999) {
 					number = (number + 500) / 1000;
-					printf(FMT("%4lluG ","%lluG "),number);
+					if (number > 9999) {
+						number = (number + 500) / 1000;
+						printf(FMT("%4lluT ","%lluT "), (unsigned long long)number);
 				}
-				else printf(FMT("%4lluM ","%lluM "), number);
+					else printf(FMT("%4lluG ","%lluG "), (unsigned long long)number);
+				}
+				else printf(FMT("%4lluM ","%lluM "), (unsigned long long)number);
 			} else
-				printf(FMT("%4lluK ","%lluK "), number);
+				printf(FMT("%4lluK ","%lluK "), (unsigned long long)number);
 		} else
-			printf(FMT("%5llu ","%llu "), number);
+			printf(FMT("%5llu ","%llu "), (unsigned long long)number);
 	} else
-		printf(FMT("%8llu ","%llu "), number);
+		printf(FMT("%8llu ","%llu "), (unsigned long long)number);
 }
 
 static int
@@ -839,7 +877,7 @@
 	    const struct ipt_ip *ip,
 	    int numeric)
 {
-	struct iptables_match *match = find_match(m->u.user.name, TRY_LOAD);
+	struct iptables_match *match = find_match(m->u.user.name, TRY_LOAD, NULL);
 
 	if (match) {
 		if (match->print)
@@ -867,9 +905,6 @@
 	u_int8_t flags;
 	char buf[BUFSIZ];
 
-	/* User creates a chain called "REJECT": this overrides the
-	   `REJECT' target module.  Keep feeding them rope until the
-	   revolution... Bwahahahahah */
 	if (!iptc_is_chain(targname, handle))
 		target = find_target(targname, TRY_LOAD);
 	else
@@ -917,10 +952,6 @@
 
 		if (fw->ip.iniface[0] != '\0') {
 			strcat(iface, fw->ip.iniface);
-			/* If it doesn't compare the nul-term, it's a
-			   wildcard. */
-			if (fw->ip.iniface_mask[strlen(fw->ip.iniface)] == 0)
-				strcat(iface, "+");
 		}
 		else if (format & FMT_NUMERIC) strcat(iface, "*");
 		else strcat(iface, "any");
@@ -934,10 +965,6 @@
 
 		if (fw->ip.outiface[0] != '\0') {
 			strcat(iface, fw->ip.outiface);
-			/* If it doesn't compare the nul-term, it's a
-			   wildcard. */
-			if (fw->ip.outiface_mask[strlen(fw->ip.outiface)] == 0)
-				strcat(iface, "+");
 		}
 		else if (format & FMT_NUMERIC) strcat(iface, "*");
 		else strcat(iface, "any");
@@ -979,7 +1006,7 @@
 			target->print(&fw->ip, t, format & FMT_NUMERIC);
 	} else if (t->u.target_size != sizeof(*t))
 		printf("[%u bytes of unknown target data] ",
-		       t->u.target_size - sizeof(*t));
+		       (unsigned int)(t->u.target_size - sizeof(*t)));
 
 	if (!(format & FMT_NONEWLINE))
 		fputc('\n', stdout);
@@ -996,6 +1023,15 @@
 }
 
 
+static void set_revision(char *name, u_int8_t revision)
+{
+	/* Old kernel sources don't have ".revision" field,
+	   but we stole a byte from name. */
+	name[IPT_FUNCTION_MAXNAMELEN - 2] = '\0';
+	name[IPT_FUNCTION_MAXNAMELEN - 1] = revision;
+}
+
+
 // ---------------------------------------------------------------------
 
 
@@ -1129,8 +1165,7 @@
 			chain->pkts++;
 			continue;
 		}
-
-		counters = iptc_read_counter(chain->name, chain->pkts, &handle);
+		counters = iptc_read_counter(chain->name, chain->pkts, &handle);  // ???? why chain->pkts
 		if (counters) {
 			iptc_zero_counter(chain->name, chain->pkts, &handle);
 			chain->pkts++;
@@ -1192,7 +1227,7 @@
  * 
  */
 static int
-prepare_entry (raw_rule_type *d, struct ipt_entry **e)
+prepare_entry (raw_rule_type *d, struct ipt_entry **e, struct iptables_rule_match **matches)
 {
 	struct ipt_entry fw;
 	unsigned int naddrs = 0;
@@ -1200,10 +1235,14 @@
 	struct iptables_match *m;
 	struct iptables_target *target = NULL;
 	struct iptables_target *t;
+
+	struct iptables_rule_match *matchp;
+
 	size_t size;
 	int inverse;
 	int c,argc;
 	int invert = 0;
+	int proto_used = 0;
 
 	bzero(&fw, sizeof(fw));
 
@@ -1233,7 +1272,6 @@
 
 	for (m = iptables_matches; m; m = m->next) {
 		m->mflags = 0;
-		m->used = 0;
 	}
 
 	for (t = iptables_targets; t; t = t->next) {
@@ -1279,6 +1317,8 @@
 	target->t = xcalloc(1, size);
 	target->t->u.target_size = size;
 	strcpy(target->t->u.user.name, d->target);
+	set_revision(target->t->u.user.name, target->revision);
+	if (target->init != NULL)
 	target->init(target->t, &fw.nfcache);
 
 	if(check_inverse_type(d->protocol))
@@ -1290,7 +1330,7 @@
 	}
 
 	if (d->protocol[0] != '\0' && d->protocol[0] != 'i') {
-		m = find_proto(d->protocol, LOAD_MUST_SUCCEED, 0);
+		m = find_proto(d->protocol, LOAD_MUST_SUCCEED, 0, matches);
 		size = IPT_ALIGN(sizeof(struct ipt_entry_match)) + m->size;
 		m->m = xcalloc(size, 1);
 		m->m->u.match_size = size;
@@ -1338,7 +1378,7 @@
 		while ((c = getopt_long(argc, d->extension,"-m:", opts, NULL))!= -1) {
 			switch 	(c) {
 				case 'm':
-					m = find_match(optarg, LOAD_MUST_SUCCEED);
+					m = find_match(optarg, LOAD_MUST_SUCCEED, matches);
 					size = IPT_ALIGN(sizeof(struct ipt_entry_match)) + m->size;
 					m->m = xcalloc(1, size);
 					m->m->u.match_size = size;
@@ -1361,32 +1401,80 @@
 					exit(1);
 
 				default: 
-					for (m = iptables_matches; m; m = m->next) {
-						if (!m->used)
-							continue;
-						if (m->parse(c - m->option_offset,
+
+					/* FIXME: This scheme doesn't allow two of the same
+					   matches --RR */
+					if (!target
+					    || !(target->parse(c - target->option_offset,
+							       d->extension, invert,
+							       &target->tflags,
+							       &fw, &target->t))) {
+						for (matchp = *matches; matchp; matchp = matchp->next) {
+							if (matchp->match->parse(c - matchp->match->option_offset,
 								d->extension, invert,
-								&m->mflags,
-								&fw, &fw.nfcache, &m->m))
+										 &matchp->match->mflags,
+										 &fw,
+										 &fw.nfcache,
+										 &matchp->match->m))
 							break;
 					}
-					break;
+
+						if (m == NULL
+						    && d->protocol
+						    && (!find_proto(d->protocol, DONT_LOAD,
+								    0, NULL) 
+							|| (find_proto(d->protocol, DONT_LOAD,
+								       0, NULL)
+							    && (proto_used == 0))
+							    )
+						    && (m = find_proto(d->protocol, TRY_LOAD,
+								       0, matches))) {
+							/* Try loading protocol */
+							size_t size;
+							
+							proto_used = 1;
+
+							size = IPT_ALIGN(sizeof(struct ipt_entry_match))
+								+ m->size;
+
+							m->m = xcalloc(1, size);
+							m->m->u.match_size = size;
+							strcpy(m->m->u.user.name, m->name);
+							set_revision(m->m->u.user.name,
+								     m->revision);
+							if (m->init != NULL)
+								m->init(m->m, &fw.nfcache);
+
+							opts = merge_options(opts,
+									     m->extra_opts, &m->option_offset);
+							
+							optind--;
+							continue;
+						}
+
+						m = matchp ? matchp->match : NULL;
+						if (!m)
+							exit_error(PARAMETER_PROBLEM,
+								   "Unknown arg `%s'",
+								   d->extension);
 			}
 		}
 	}
-	for (m = iptables_matches; m; m = m->next) {
-		if (!m->used)
-			continue;
-		m->final_check(m->mflags);
 	}
 
+	for (matchp = *matches; matchp; matchp = matchp->next)
+		matchp->match->final_check(matchp->match->mflags);
+
+	if (target)
 	target->final_check(target->tflags);
-	*e = generate_entry(&fw, iptables_matches, target->t);
+
+	*e = generate_entry(&fw, *matches, target->t);
+	free(target->t);
+
 
 	if (!handle) if (!(handle = iptc_init("filter")))
 			    exit_error(PARAMETER_PROBLEM, 
 				"iptables: %s\n", iptc_strerror(errno));
-			
 	return 0;
 }
 
@@ -1399,9 +1487,11 @@
 insert_rule(raw_rule_type *d, int rule_num)
 {
 	struct ipt_entry *e = NULL;
+	struct iptables_rule_match *matches = NULL;
+
 	int ret=1;
 
-	if (prepare_entry(d, &e)!=0)
+	if (prepare_entry(d, &e, &matches)!=0)
 		return (1);
 	if (verbose>1) {
 		printf("Inserting rule\n");
@@ -1421,9 +1511,10 @@
 replace_rule (raw_rule_type *d, int rule_num)
 {
 	struct ipt_entry *e = NULL;
+	struct iptables_rule_match *matches = NULL;
 	int ret=1;
 
-	if (prepare_entry(d, &e)!=0)
+	if (prepare_entry(d, &e, &matches)!=0)
 		return (1);
 
 	if (verbose>1) {
@@ -1449,8 +1540,9 @@
 append_rule (raw_rule_type *d)
 {
 	struct ipt_entry *e = NULL;
+	struct iptables_rule_match *matches = NULL;
 	
-	if (prepare_entry(d, &e)!=0)
+	if (prepare_entry(d, &e, &matches)!=0)
 		return (1);
 	
 	if (verbose>1) {
@@ -1472,9 +1564,11 @@
 {
 	struct ipt_entry *e = NULL;
 	unsigned char *mask = NULL;
+	struct iptables_rule_match *matches = NULL;
+
 	int ret=1;
 
-	if (prepare_entry(d, &e)!=0)
+	if (prepare_entry(d, &e, &matches)!=0)
 		return (1);
 
 	if (verbose>1) {
@@ -1482,7 +1576,7 @@
 		print_firewall_line(e, handle);
 	}
 
-	mask = make_delete_mask(e);
+	mask = make_delete_mask(e, matches);
 	ret &= iptc_delete_entry(d->dest, e, mask, &handle);
 	free(e);
 	return ret;
@@ -1492,10 +1586,8 @@
 delete_num_rule (char *chain, int num)
 {
 	struct ipt_entry *e = NULL;
-	unsigned char *mask = NULL;
 	int ret = 1;
 
-	mask = make_delete_mask(e);
 	ret &= iptc_delete_num_entry(chain, num, &handle);
 	free(e);
 	return ret;
@@ -1588,11 +1680,9 @@
 	if (!handle)
 		handle = iptc_init("filter");
 
-	if (!handle) {
-//		try to insmod the module if iptc_init failed
-		iptables_insmod("ip_tables", modprobe);
+	/* try to insmod the module if iptc_init failed */
+	if (!handle && iptables_insmod("ip_tables", modprobe) != -1)
 		handle = iptc_init("filter");
-	}
 
 	if (!handle) {
 		fprintf(stderr, "ipac-ng: can't initialize iptables table `filter'\n"
@@ -1617,7 +1707,6 @@
 setup_rules(void)
 {
 	raw_rule_type *d, *d1;
-	char targ[MAX_RULE_NAME_LENGTH+2];
 	char chain[MAX_RULE_NAME_LENGTH+2];
 	FILE *frunfile;
 
diff -ruwN ipac-ng-1.31.orig/agents/iptables/libip4tc.c ipac-ng-1.31/agents/iptables/libip4tc.c
--- ipac-ng-1.31.orig/agents/iptables/libip4tc.c	2003-07-06 12:33:23.000000000 +0200
+++ ipac-ng-1.31/agents/iptables/libip4tc.c	2005-04-30 13:01:36.000000000 +0200
@@ -16,6 +16,7 @@
 #include <errno.h>
 #include <stdlib.h>
 #include <stdio.h>
+#include <unistd.h>
 
 #ifdef DEBUG_CONNTRACK
 #define inline
@@ -90,6 +91,7 @@
 #define TC_SET_POLICY		iptc_set_policy
 #define TC_GET_RAW_SOCKET	iptc_get_raw_socket
 #define TC_INIT			iptc_init
+#define TC_FREE			iptc_free
 #define TC_COMMIT		iptc_commit
 #define TC_STRERROR		iptc_strerror
 
@@ -127,8 +129,8 @@
 	size_t i;
 	STRUCT_ENTRY_TARGET *t;
 
-	printf("Entry %u (%lu):\n", entry2index(handle, e),
-	       entry2offset(handle, e));
+	printf("Entry %u (%lu):\n", iptcb_entry2index(handle, e),
+	       iptcb_entry2offset(handle, e));
 	printf("SRC IP: %u.%u.%u.%u/%u.%u.%u.%u\n",
 	       IP_PARTS(e->ip.src.s_addr),IP_PARTS(e->ip.smsk.s_addr));
 	printf("DST IP: %u.%u.%u.%u/%u.%u.%u.%u\n",
@@ -143,21 +145,10 @@
 	printf("Flags: %02X\n", e->ip.flags);
 	printf("Invflags: %02X\n", e->ip.invflags);
 	printf("Counters: %llu packets, %llu bytes\n",
-	       e->counters.pcnt, e->counters.bcnt);
+	       (unsigned long long)e->counters.pcnt, (unsigned long long)e->counters.bcnt);
 	printf("Cache: %08X ", e->nfcache);
 	if (e->nfcache & NFC_ALTERED) printf("ALTERED ");
 	if (e->nfcache & NFC_UNKNOWN) printf("UNKNOWN ");
-	if (e->nfcache & NFC_IP_SRC) printf("IP_SRC ");
-	if (e->nfcache & NFC_IP_DST) printf("IP_DST ");
-	if (e->nfcache & NFC_IP_IF_IN) printf("IP_IF_IN ");
-	if (e->nfcache & NFC_IP_IF_OUT) printf("IP_IF_OUT ");
-	if (e->nfcache & NFC_IP_TOS) printf("IP_TOS ");
-	if (e->nfcache & NFC_IP_PROTO) printf("IP_PROTO ");
-	if (e->nfcache & NFC_IP_OPTIONS) printf("IP_OPTIONS ");
-	if (e->nfcache & NFC_IP_TCPFLAGS) printf("IP_TCPFLAGS ");
-	if (e->nfcache & NFC_IP_SRC_PT) printf("IP_SRC_PT ");
-	if (e->nfcache & NFC_IP_DST_PT) printf("IP_DST_PT ");
-	if (e->nfcache & NFC_IP_PROTO_UNKNOWN) printf("IP_PROTO_UNKNOWN ");
 	printf("\n");
 
 	IPT_MATCH_ITERATE(e, print_match);
@@ -182,60 +173,48 @@
 	return 0;
 }
 
-static int
+static unsigned char *
 is_same(const STRUCT_ENTRY *a, const STRUCT_ENTRY *b, unsigned char *matchmask)
 {
 	unsigned int i;
-	STRUCT_ENTRY_TARGET *ta, *tb;
 	unsigned char *mptr;
 
 	/* Always compare head structures: ignore mask here. */
 	if (a->ip.src.s_addr != b->ip.src.s_addr
 	    || a->ip.dst.s_addr != b->ip.dst.s_addr
 	    || a->ip.smsk.s_addr != b->ip.smsk.s_addr
-	    || a->ip.smsk.s_addr != b->ip.smsk.s_addr
+	    || a->ip.dmsk.s_addr != b->ip.dmsk.s_addr
 	    || a->ip.proto != b->ip.proto
 	    || a->ip.flags != b->ip.flags
 	    || a->ip.invflags != b->ip.invflags)
-		return 0;
+		return NULL;
 
 	for (i = 0; i < IFNAMSIZ; i++) {
 		if (a->ip.iniface_mask[i] != b->ip.iniface_mask[i])
-			return 0;
+			return NULL;
 		if ((a->ip.iniface[i] & a->ip.iniface_mask[i])
 		    != (b->ip.iniface[i] & b->ip.iniface_mask[i]))
-			return 0;
+			return NULL;
 		if (a->ip.outiface_mask[i] != b->ip.outiface_mask[i])
-			return 0;
+			return NULL;
 		if ((a->ip.outiface[i] & a->ip.outiface_mask[i])
 		    != (b->ip.outiface[i] & b->ip.outiface_mask[i]))
-			return 0;
+			return NULL;
 	}
 
 	if (a->nfcache != b->nfcache
 	    || a->target_offset != b->target_offset
 	    || a->next_offset != b->next_offset)
-		return 0;
+		return NULL;
 
 	mptr = matchmask + sizeof(STRUCT_ENTRY);
 	if (IPT_MATCH_ITERATE(a, match_different, a->elems, b->elems, &mptr))
-		return 0;
+		return NULL;
 
-	ta = GET_TARGET((STRUCT_ENTRY *)a);
-	tb = GET_TARGET((STRUCT_ENTRY *)b);
-	if (ta->u.target_size != tb->u.target_size)
-		return 0;
-	if (strcmp(ta->u.user.name, tb->u.user.name) != 0)
-		return 0;
-
-	mptr += sizeof(*ta);
-	if (target_different(ta->data, tb->data,
-			     ta->u.target_size - sizeof(*ta), mptr))
-		return 0;
-
-   	return 1;
+	return mptr;
 }
 
+#if 0
 /***************************** DEBUGGING ********************************/
 static inline int
 unconditional(const struct ipt_ip *ip)
@@ -290,20 +269,20 @@
 		assert(t->verdict == -NF_DROP-1
 		       || t->verdict == -NF_ACCEPT-1
 		       || t->verdict == RETURN
-		       || t->verdict < (int)h->entries.size);
+		       || t->verdict < (int)h->entries->size);
 
 		if (t->verdict >= 0) {
 			STRUCT_ENTRY *te = get_entry(h, t->verdict);
 			int idx;
 
-			idx = entry2index(h, te);
+			idx = iptcb_entry2index(h, te);
 			assert(strcmp(GET_TARGET(te)->u.user.name,
 				      IPT_ERROR_TARGET)
 			       != 0);
 			assert(te != e);
 
 			/* Prior node must be error node, or this node. */
-			assert(t->verdict == entry2offset(h, e)+e->next_offset
+			assert(t->verdict == iptcb_entry2offset(h, e)+e->next_offset
 			       || strcmp(GET_TARGET(index2entry(h, idx-1))
 					 ->u.user.name, IPT_ERROR_TARGET)
 			       == 0);
@@ -335,7 +314,7 @@
 	return 0;
 }
 
-#ifndef NDEBUG
+#ifdef IPTC_DEBUG
 /* Do every conceivable sanity check on the handle */
 static void
 do_check(TC_HANDLE_T h, unsigned int line)
@@ -364,35 +343,90 @@
 
 		user_offset = h->info.hook_entry[NF_IP_LOCAL_OUT];
 	} else if (strcmp(h->info.name, "nat") == 0) {
-		assert(h->info.valid_hooks
+		assert((h->info.valid_hooks
 		       == (1 << NF_IP_PRE_ROUTING
 			   | 1 << NF_IP_POST_ROUTING
-			   | 1 << NF_IP_LOCAL_OUT));
+			    | 1 << NF_IP_LOCAL_OUT)) ||
+		       (h->info.valid_hooks
+			== (1 << NF_IP_PRE_ROUTING
+			    | 1 << NF_IP_LOCAL_IN
+			    | 1 << NF_IP_POST_ROUTING
+			    | 1 << NF_IP_LOCAL_OUT)));
 
 		assert(h->info.hook_entry[NF_IP_PRE_ROUTING] == 0);
 
 		n = get_chain_end(h, 0);
+
 		n += get_entry(h, n)->next_offset;
 		assert(h->info.hook_entry[NF_IP_POST_ROUTING] == n);
-
 		n = get_chain_end(h, n);
+
 		n += get_entry(h, n)->next_offset;
 		assert(h->info.hook_entry[NF_IP_LOCAL_OUT] == n);
-
 		user_offset = h->info.hook_entry[NF_IP_LOCAL_OUT];
+
+		if (h->info.valid_hooks & (1 << NF_IP_LOCAL_IN)) {
+			n = get_chain_end(h, n);
+			n += get_entry(h, n)->next_offset;
+			assert(h->info.hook_entry[NF_IP_LOCAL_IN] == n);
+			user_offset = h->info.hook_entry[NF_IP_LOCAL_IN];
+		}
+
 	} else if (strcmp(h->info.name, "mangle") == 0) {
+		/* This code is getting ugly because linux < 2.4.18-pre6 had
+		 * two mangle hooks, linux >= 2.4.18-pre6 has five mangle hooks
+		 * */
+		assert((h->info.valid_hooks
+			== (1 << NF_IP_PRE_ROUTING
+			    | 1 << NF_IP_LOCAL_OUT)) || 
+		       (h->info.valid_hooks
+			== (1 << NF_IP_PRE_ROUTING
+			    | 1 << NF_IP_LOCAL_IN
+			    | 1 << NF_IP_FORWARD
+			    | 1 << NF_IP_LOCAL_OUT
+			    | 1 << NF_IP_POST_ROUTING)));
+
+		/* Hooks should be first five */
+		assert(h->info.hook_entry[NF_IP_PRE_ROUTING] == 0);
+
+		n = get_chain_end(h, 0);
+
+		if (h->info.valid_hooks & (1 << NF_IP_LOCAL_IN)) {
+			n += get_entry(h, n)->next_offset;
+			assert(h->info.hook_entry[NF_IP_LOCAL_IN] == n);
+			n = get_chain_end(h, n);
+		}
+
+		if (h->info.valid_hooks & (1 << NF_IP_FORWARD)) {
+			n += get_entry(h, n)->next_offset;
+			assert(h->info.hook_entry[NF_IP_FORWARD] == n);
+			n = get_chain_end(h, n);
+		}
+
+		n += get_entry(h, n)->next_offset;
+		assert(h->info.hook_entry[NF_IP_LOCAL_OUT] == n);
+		user_offset = h->info.hook_entry[NF_IP_LOCAL_OUT];
+
+		if (h->info.valid_hooks & (1 << NF_IP_POST_ROUTING)) {
+			n = get_chain_end(h, n);
+			n += get_entry(h, n)->next_offset;
+			assert(h->info.hook_entry[NF_IP_POST_ROUTING] == n);
+			user_offset = h->info.hook_entry[NF_IP_POST_ROUTING];
+		}
+	} else if (strcmp(h->info.name, "raw") == 0) {
 		assert(h->info.valid_hooks
 		       == (1 << NF_IP_PRE_ROUTING
 			   | 1 << NF_IP_LOCAL_OUT));
 
-		/* Hooks should be first two */
+		/* Hooks should be first three */
 		assert(h->info.hook_entry[NF_IP_PRE_ROUTING] == 0);
 
-		n = get_chain_end(h, 0);
+		n = get_chain_end(h, n);
 		n += get_entry(h, n)->next_offset;
 		assert(h->info.hook_entry[NF_IP_LOCAL_OUT] == n);
 
 		user_offset = h->info.hook_entry[NF_IP_LOCAL_OUT];
+
 #ifdef NF_IP_DROPPING
 	} else if (strcmp(h->info.name, "drop") == 0) {
 		assert(h->info.valid_hooks == (1 << NF_IP_DROPPING));
@@ -425,8 +459,8 @@
 		assert(unconditional(&e->ip));
 		assert(e->target_offset == sizeof(*e));
 		t = (STRUCT_STANDARD_TARGET *)GET_TARGET(e);
-		assert(t->target.u.target_size == IPT_ALIGN(sizeof(*t)));
-		assert(e->next_offset == sizeof(*e) + IPT_ALIGN(sizeof(*t)));
+		assert(t->target.u.target_size == ALIGN(sizeof(*t)));
+		assert(e->next_offset == sizeof(*e) + ALIGN(sizeof(*t)));
 
 		assert(strcmp(t->target.u.user.name, STANDARD_TARGET)==0);
 		assert(t->verdict == -NF_DROP-1 || t->verdict == -NF_ACCEPT-1);
@@ -458,6 +492,8 @@
 	/* Final entry must be error node */
 	assert(strcmp(GET_TARGET(index2entry(h, h->new_number-1))
 		      ->u.user.name,
-		      IPT_ERROR_TARGET) == 0);
+		      ERROR_TARGET) == 0);
 }
-#endif /*NDEBUG*/
+#endif /*IPTC_DEBUG*/
+
+#endif
